﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using Styx.Logic.Combat;
using Styx.WoWInternals.World;
using Styx;
using Styx.Helpers;

namespace PrinceOfDarkness
{
    public class FelPuppy
    {
        //this one aims to help controlling warlock pets
        public static WoWUnit Pet { get { return PrinceOfDarkness.Me.Pet; } }

        public static bool IsValid { get { return Pet != null && !Pet.Dead;  } }

        private static Dictionary<WoWSpell, int> spells; //spell - book index

        //private static WoWUnit findCaster()
        //{
        //    //List spells = ObjectManager.GetObjectsOfType<WoWSpell>().Where(s => s.GetSpellEffect() == WoWSpellEffectType.Heal
        //    WoWUnit findCaster = ObjectManager.GetObjectsOfType<WoWUnit>()
        //            .Where(u => u.IsCasting && (u.IsTargetingMeOrPet || u.CastingSpellId().
        //             && u.CanInterruptCurrentSpellCast && u.Location.DistanceSqr(Pet.Location) <= 30 &&
        //             GameWorld.IsInLineOfSight(Pet.Location, u.Location)).FirstOrDefault();

        //    if (findCaster != null && findCaster.IsValid)
        //    {
        //        return findCaster;
        //    }
        //    return null;
        //}

        //private static WoWUnit findBuffs()
        //{                 //Styx.Logic.Combat.WoWDispelType.Magic
        //    List<WoWUnit> findBuffs = ObjectManager.GetObjectsOfType<WoWUnit>()
        //            .Where(u => u.IsTargetingMeOrPet && u.Location.DistanceSqr(Pet.Location) <= 30 &&
        //             GameWorld.IsInLineOfSight(Pet.Location, u.Location)).OrderBy(u => u.Distance).ToList();

        //    if (findBuffs != null && findBuffs.Count > 1)
        //    {
        //        //var savedUnit = new WoWUnit();
        //        foreach (WoWUnit unit in findBuffs)
        //        {
        //            var auras = unit.GetAllAuras();
        //            foreach (var aura in auras)
        //            {
        //                if (aura.Spell.DispelType == WoWDispelType.Magic)
        //                {
        //                    return unit;
        //                }
        //            }
        //        }
        //    }
        //    return null;
        //}
        
        List<string> lua = Lua.GetReturnValues(@"
                local ids = ''
                for j = 1, 32 do
                    local _, spellID = GetSpellBookItemInfo(j, BOOKTYPE_PET)
                    if spellID ~= nil then
                        ids = ids .. j.. ':' .. spellID .. ','
                    else
                        break
                    end
                end
                return ids
            ");

      //   Lua.DoString("for i=GetNumGuildBankTabs(), 1, -1 do QueryGuildBankTab(i) end SetCurrentGuildBankTab({0}) ", tab == 0 ? 1 : tab);
        //devourMagic=2, spellLock=5
        static void castSpellLuaFocus(int spellEntry, WoWUnit unit)
        {
             var me = ObjectManager.Me;
             var guid = unit.Guid;
             //string lua = string.Format("CastSpell({0}, BOOKTYPE_PET)",         (\"focus\");"
            //Lua.DoString("CastPetAction(spellId, unit)");

            using (new FrameLock())
            {
                me.SetFocus(guid);

                Logging.Write("casting spellEntry:{0} on {1}", spellEntry, unit);
                PrinceOfDarkness.Debug("Focus set, now try cast petSpellEntry:{0} on {1}.", spellEntry, unit);
                if (me.FocusedUnit != null && me.FocusedUnitGuid == guid)
                    Lua.DoString("CastPetAction({0}, 'focus')", spellEntry);
            }
        }

        static void castSpellLuaTarget(int spellEntry)
        {
            var me = ObjectManager.Me;
            //string lua = string.Format("CastSpell({0}, BOOKTYPE_PET)",         (\"focus\");"
            //Lua.DoString("CastPetAction(spellId, unit)");

            using (new FrameLock())
            {
                Logging.Write("casting petEntry:{0} on my target.", spellEntry);
                PrinceOfDarkness.Debug("try cast petSpellEntry:{0} on my target.", spellEntry);
                Lua.DoString("CastPetAction({0}, 'target')", spellEntry);
            }
        }

 //       for i=1, NUM_PET_ACTION_SLOTS, 1 do
 //  local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
 //  if ( name == "Sacrifice" ) then
 //    CastPetAction(i);
 //  end
 //end

        //must call this periodicaly


        public static void Pulse()
        {
            //handle fake autocast spells
            CheckAutoCast();
        }

        public static bool Cast (WoWSpell spell)
        {
            if (spell == null)
                return false;
            PrinceOfDarkness.Debug("Trying to cast pet spell: " + spell.Name);
            if (!HasSpell(spell))
            {
                PrinceOfDarkness.Debug("FelPuppy.Cast error: pet don't have spell id=" + spell.Id);
                return false;
            }

            if (spell.Cooldown)
            {
                PrinceOfDarkness.Debug("Pet's spell is on cooldown.");
                return false;
            }

            if (Pet.IsCasting)
            {
                PrinceOfDarkness.Debug("Pet is already casting");
                return false;
            }

            PrinceOfDarkness.Debug("Pet casts spell: " + spell.Name);
            string lua = string.Format("CastSpell({0}, BOOKTYPE_PET)", 
                spells.First(keypair => keypair.Key.Id == spell.Id).Value);
            PrinceOfDarkness.Debug("Inject lua: /script " + lua);
            Lua.DoString(lua);
            return true;
        }

        //public static bool Cast(WoWSpell spell, WoWUnit unit)
        //{
        //    var me = StyxWoW.Me;
        //    var currentTarget = me.CurrentTarget;

        //    if (spell == null)
        //        return false;
        //    PrinceOfDarkness.Debug("Trying to cast pet spell: " + spell.Name);
        //    if (!HasSpell(spell))
        //    {
        //        PrinceOfDarkness.Debug("FelPuppy.Cast error: pet don't have spell id=" + spell.Id);
        //        return false;
        //    }

        //    if (spell.Cooldown)
        //    {
        //        PrinceOfDarkness.Debug("Pet's spell is on cooldown.");
        //        return false;
        //    }

        //    if (Pet.IsCasting)
        //    {
        //        PrinceOfDarkness.Debug("Pet is already casting");
        //        return false;
        //    }


        //    //unit.Target();

        //    PrinceOfDarkness.Debug("Pet casts spell: " + spell.Name);
        //    string lua = string.Format("CastSpell({0}, BOOKTYPE_PET)",
        //        spells.First(keypair => keypair.Key.Id == spell.Id).Value);
        //    PrinceOfDarkness.Debug("Inject lua: /script " + lua);
        //    Lua.DoString(lua);
        //    currentTarget.Target();
        //    return true;
        //}

        //******************************************************************
        //enables auto-casting pet spells that arent in wow, like felguard's stun
        //XXX storing spell id instead of wowspell instances as they dont have comparators........

        private static Dictionary<int, AutoCastCondition> autoCastSpells = new Dictionary<int, AutoCastCondition>();

        public enum AutoCastCondition
        {
            somethingHasBuffs,
            somethingCastingOnMe,
            PetNearTarget
        }

        public static void AddAutoCast(WoWSpell spell, AutoCastCondition condition)
        {
            PrinceOfDarkness.Debug("Faking autocast pet spell: {0} IF {1}", spell.Name, condition.ToString());
            autoCastSpells.Add(spell.Id, condition);
        }

        public static void RemoveAutoCast(WoWSpell spell)
        {
            PrinceOfDarkness.Debug("Removed fake autocast pet spell: " + spell.Name);
            autoCastSpells.Remove(spell.Id);
        }

        public static void RemoveAllAutoCast()
        {
            foreach (var pair in autoCastSpells)
                RemoveAutoCast(WoWSpell.FromId(pair.Key));
        }

        private static void CheckAutoCast()
        {
            if (!IsValid)
                return;

            foreach (var pair in autoCastSpells)
            {
                WoWSpell spell = WoWSpell.FromId(pair.Key);
                
                if (CanCast(spell)) //
                {
                    if (pair.Value == AutoCastCondition.PetNearTarget)
                    {
                        //check autocast condition
                        switch (pair.Value)
                        {
                            case AutoCastCondition.PetNearTarget:
                                if (Pet.CurrentTarget != null &&
                                    Pet.CurrentTarget.IsAlive &&
                                    Pet.CurrentTarget.Location.DistanceSqr(Pet.Location) < 20)
                                    break;
                                else
                                    continue;
                            default:
                                break;
                        }

                        Cast(spell);
                    }
                    if (pair.Value == AutoCastCondition.somethingCastingOnMe)
                    {
                        if (PrinceOfDarkness.Me.CurrentTarget.IsCasting)
                        {
                            WoWUnit tar = StyxWoW.Me.CurrentTarget;
                            var check = checkTarget();

                            if (check)
                                castSpellLuaTarget(2);
                        }
                        else
                        {
                            WoWUnit findCaster = ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => inPetRange(u) && u.IsCasting && 
                            u.IsHostile && !u.IsPet && checkUnit(u) && (u.IsTargetingMeOrPet || isCastingHeals(u))).FirstOrDefault();

                            if (findCaster != null && findCaster.IsValid && findCaster.IsCasting)
                                castSpellLuaFocus(2, findCaster);
                        }
                    }
                    if (pair.Value == AutoCastCondition.somethingHasBuffs)
                    {
                        WoWUnit tar = StyxWoW.Me.CurrentTarget;
                        TimeSpan threeSec = new TimeSpan(0,0,3);
                        TimeSpan tenMin = new TimeSpan(0,10,0);

                        var tarBuffs = PrinceOfDarkness.Me.CurrentTarget.ActiveAuras.Where(a => a.Value.Spell.DispelType == WoWDispelType.Magic
                            && durCheck(a.Value)).FirstOrDefault();

                        if (tarBuffs.Value != null && tarBuffs.Value.Spell.IsValid)
                            castSpellLuaTarget(3);
                        else
                        {
                            WoWUnit findBuffs = ObjectManager.GetObjectsOfType<WoWUnit>().Where(u => inPetRange(u) && hasBuff(u)).FirstOrDefault();

                            if (findBuffs != null && findBuffs.IsValid)
                                castSpellLuaFocus(3, findBuffs);
                        }
                    }
                }
            }
        }

        //Dictionary<uint, int> getAuras(WoWUnit unit)
        //{
        //    TimeSpan threeSec = new TimeSpan(0,0,3);
        //    TimeSpan tenMin = new TimeSpan(0, 10, 0);
            
        //    var auraList = unit.ActiveAuras;
        //    IEnumerable<WoWAura> tmpItemlist = from aura in auraList 
        //                                       where aura.Value.TimeLeft > threeSec && aura.Value.TimeLeft < tenMin
        //                                       && aura.Value.Spell.DispelType == WoWDispelType.Magic
        //                                       select aura;
            
        //        string[] entries = ItemID.Split(',');
        //        if (entries.Length > 0)
        //        {
        //            foreach (var entry in entries)
        //            {
        //                uint itemID;
        //                uint.TryParse(entry.Trim(), out itemID);
        //                itemList.Add(itemID, Mail == DepositWithdrawAmount.Amount ?
        //                Amount : Util.GetCarriedItemCount(itemID));
        //            }
        //        }
        //        else
        //        {
        //            Professionbuddy.Err("No ItemIDs are specified");
        //            IsDone = true;
        //        }
        //    }
        //    return itemList;
        //}

        //******************************************************************
        //static bool validDurations(WoWAura aura)
        //{

        //}


        //static bool checkTarCast(WoWUnit unit)
        //{
        //    var tar = PrinceOfDarkness.Me.CurrentTarget.ToPlayer();

        //    if (checkClass(unit)

        //}
        static bool checkTarget()
        {
            var tar = PrinceOfDarkness.Me.CurrentTarget;

            if (tar != null && tar.IsValid && checkClass(tar) && canInterrupt(tar))
                return true;
            return false;
        }

        static bool checkUnit(WoWUnit unit)
        {
            if (unit != null && unit.IsValid && checkClass(unit) && canInterrupt(unit))
                return true;
            return false;
        }

        static bool canInterrupt(WoWUnit unit)
        {
            var spell = unit.CastingSpell;
            bool can = unit.CanInterruptCurrentSpellCast;

            if (spell != null && can)
                return true;
            return false;
        }

        static bool checkClass(WoWUnit unit)
        {
            if (unit.Class == Styx.Combat.CombatRoutine.WoWClass.Warrior || unit.Class == Styx.Combat.CombatRoutine.WoWClass.DeathKnight 
                || unit.Class == Styx.Combat.CombatRoutine.WoWClass.Hunter || unit.Class == Styx.Combat.CombatRoutine.WoWClass.Rogue)
                return false;
            return true;
        }

        static bool inPetRange(WoWUnit unit)
        {
            var dist = unit.Location.Distance2D(PrinceOfDarkness.Me.Pet.Location);

            if (dist != null && dist <= 30)
                return true;
            return false;
        }


        static bool isCastingHeals(WoWUnit unit)
        {
            var spell = unit.CastingSpell;

            if (spell.Mechanic == WoWSpellMechanic.Healing && spell.CastTime >= 1)
                return true;
            return false;
        }

        static bool hasBuff(WoWUnit unit)
        {
            var unitBuffs = unit.ActiveAuras.Where(b => b.Value.Spell.DispelType == WoWDispelType.Magic && durCheck(b.Value)).ToList();

            if (unitBuffs != null && unitBuffs.Count > 0)
                return true;
            return false;
        }

        static bool durCheck(WoWAura aura)
        {
            TimeSpan threeSec = new TimeSpan(0,0,3);
            TimeSpan tenMin = new TimeSpan(0, 10, 0);

            if (aura.TimeLeft > threeSec)
                return true;
            return false;
        }

        public static bool CanCast(WoWSpell spell)
        {
            return IsValid && HasSpell(spell) && !spell.Cooldown && !Pet.IsCasting && !Pet.Stunned;
        }

        public static bool HasSpell(WoWSpell spell)
        {
            //awful.
            return spell != null && spells != null && spells.Any(keypair => keypair.Key.Id == spell.Id);
        }

        public static void HandlePetBarUpdated(object sender, LuaEventArgs args)
        {
            PrinceOfDarkness.Debug("FelPuppy: Detected pet bar update. Reloading pet skills...");
            UpdatePetSkills();
        }

        public static void UpdatePetSkills () {
            spells = new Dictionary<WoWSpell, int>();

            if (PrinceOfDarkness.Me.Pet == null)
                return;

            List<string> lua = Lua.GetReturnValues(@"
                local ids = ''
                for j = 1, 32 do
                    local _, spellID = GetSpellBookItemInfo(j, BOOKTYPE_PET)
                    if spellID ~= nil then
                        ids = ids .. j.. ':' .. spellID .. ','
                    else
                        break
                    end
                end
                return ids
            ");

            if (lua == null || lua.Count == 0)
            {
                PrinceOfDarkness.Debug("WARN: FelPuppy.UpdatePetSkills lua injection failed!!!");
                return;
            }

            foreach (var raw in lua[0].Split(','))
            {
                if (raw == null || raw.Length < 1)
                    continue;
                int id = 0;
                int spellid = 0;
                int.TryParse(raw.Substring(0, raw.IndexOf(':')), out id);
                int.TryParse(raw.Substring(raw.IndexOf(':')+1), out spellid);
                if (id < 1 || spellid < 1)
                    continue;
                WoWSpell spell = WoWSpell.FromId(spellid);
                if (spell == null)
                    continue;
                PrinceOfDarkness.Debug("Found pet spell: Key={0}, Name={1}", id, spell.Name);
                spells.Add(spell, id);
            }

            PrinceOfDarkness.Debug("This pet has {0} skills.", spells.Count);
        }

        public static void Attack()
        {
            if (IsValid)
            {
                PrinceOfDarkness.Debug("Pet attack on target");
                Lua.DoString("PetAttack()");
            }
        }

        public static void Attack(WoWUnit target)
        {
            if (IsValid && target != null && target.Attackable)
            {
                PrinceOfDarkness.Debug("Pet attack on "+target.Name);
                WoWUnit lastTarget = PrinceOfDarkness.Me.CurrentTarget;
                PrinceOfDarkness.TargetUnit(target);
                FelPuppy.Attack();
                PrinceOfDarkness.TargetUnit(lastTarget);
            }
        }
    }
}
